//+------------------------------------------------------------------+
//|                                                    MA ribbon.mq4 |
//|                                               mladenfx@gmail.com |
//|                                                                  |
//| original idea by Jose Silva                                      |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
// modification kinonen Fev 2009
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 C'0,70,0'
#property indicator_color2 C'70,0,0'
#property indicator_color3 Red
#property indicator_color4 Green
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 2
#property indicator_width4 2

//
//
//
//
//

extern int       T3Period1   = 13;
extern double    T3Hot1      = 0.7;
extern int       T3Price1    = PRICE_CLOSE;
extern bool      T3Original1 = true;
extern int       T3Period2   = 20;
extern double    T3Hot2      = 0.6;
extern int       T3Price2    = PRICE_CLOSE;
extern bool      T3Original2 = true;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double emas[][12];
double alpha1,alpha2;
double c11,c12,c13,c14;
double c21,c22,c23,c24;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer3); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,buffer4); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,buffer1);
   SetIndexBuffer(3,buffer2);
   
      //
      //
      //
      //
      //
      
      double a  = T3Hot1;
                c11 = -a*a*a;
                c12 =  3*(a*a+a*a*a);
                c13 = -3*(2*a*a+a+a*a*a);
                c14 = 1+3*a+a*a*a+3*a*a;
         if (T3Original1)
              alpha1 = 2.0/(1.0 + T3Period1);
         else alpha1 = 2.0/(2.0 + (T3Period1-1.0)/2.0);
         
         //
         //
         //
         //
         //
             
             a = T3Hot2;
                c21 = -a*a*a;
                c22 =  3*(a*a+a*a*a);
                c23 = -3*(2*a*a+a+a*a*a);
                c24 = 1+3*a+a*a*a+3*a*a;
         if (T3Original2)
              alpha2 = 2.0/(1.0 + T3Period2);
         else alpha2 = 2.0/(2.0 + (T3Period2-1.0)/2.0);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)  
   {
      buffer1[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price1,i),i,0,c11,c12,c13,c14,alpha1);
      buffer2[i] = iT3(iMA(NULL,0,1,0,MODE_SMA,T3Price2,i),i,6,c21,c22,c23,c24,alpha2);
      buffer3[i] = buffer1[i];
      buffer4[i] = buffer2[i];
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price, int shift,int buffer, double c1, double c2, double c3, double c4,double alpha)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0+buffer] = price;
         emas[i][1+buffer] = price;
         emas[i][2+buffer] = price;
         emas[i][3+buffer] = price;
         emas[i][4+buffer] = price;
         emas[i][5+buffer] = price;
      }
   else
      {
         emas[i][0+buffer] = emas[i-1][0+buffer]+alpha*(price            -emas[i-1][0+buffer]);
         emas[i][1+buffer] = emas[i-1][1+buffer]+alpha*(emas[i][0+buffer]-emas[i-1][1+buffer]);
         emas[i][2+buffer] = emas[i-1][2+buffer]+alpha*(emas[i][1+buffer]-emas[i-1][2+buffer]);
         emas[i][3+buffer] = emas[i-1][3+buffer]+alpha*(emas[i][2+buffer]-emas[i-1][3+buffer]);
         emas[i][4+buffer] = emas[i-1][4+buffer]+alpha*(emas[i][3+buffer]-emas[i-1][4+buffer]);
         emas[i][5+buffer] = emas[i-1][5+buffer]+alpha*(emas[i][4+buffer]-emas[i-1][5+buffer]);
      }
   return(c1*emas[i][5+buffer] + c2*emas[i][4+buffer] + c3*emas[i][3+buffer] + c4*emas[i][2+buffer]);
}

